function codebook = pq_learn_codebook(train_samples, pq_k, pq_G, pq_block_size)

if nargin < 4
    pq_block_size = pq_G;
end

dFea = size(train_samples, 1);
block_num = ceil(dFea/pq_block_size);
codebook = cell(1,block_num);
dim_beg = 1:ceil(dFea/pq_G/block_num)*pq_G:dFea;
dim_end = [dim_beg(2:end)-1 dFea];
for dind = 1:block_num
    fprintf('kmeans %d/%d\n',dind,block_num)
    cur_cb = online_learning.pq_kmeans(train_samples(dim_beg(dind):dim_end(dind),:),pq_k,pq_G);
    codebook{dind} = cur_cb;
end
codebook = cat(1,codebook{:});

end
