function pq_apply()
% compressing samples by PQ (Product Quantization) method

addpath('..');

pq_G = 4;
pq_k = 256;

train_data = load('train_data.mat');%TODO: set dataset file path
test_data = load('test_data.mat');%TODO: set dataset file path
pq_train_samples = train_data.train_data';
pq_train_samples = pq_train_samples(:,1:5000);%use first 5000 samples for pq codebook training

fprintf('learning pq codebook\n');
pq_codebook = online_learning.pq_learn_codebook(pq_train_samples, pq_k, pq_G, 1000);
save('codebook.mat', 'pq_codebook');

fprintf('compressing training data\n');
train_code = online_learning.pq_compress(train_data.train_data', pq_codebook, pq_k, pq_G);
save('train_code.mat','train_code');

fprintf('compressing test data\n');
test_code = online_learning.pq_compress(test_data.test_data', pq_codebook, pq_k, pq_G);
save('test_code.mat','test_code');

end
